package com.example.mycarctl;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.Timer;
import java.util.TimerTask;

import org.apache.http.client.HttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;

import android.content.Context;
import android.content.Intent;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

public class ControlView extends View implements OnTouchListener
{
	public static String	  ip	       = "192.168.1.186";
	private static int	      port	       = 12003;

	private Paint	          paint	       = null;
	private Paint	          paintBLK	   = null;
	private Paint	          paintM	   = null;

	private int	              spacing	   = 100;

	private int	              directX	   = 0;
	private int	              directY	   = 0;
	private int	              rotaX	       = 0;
	private int	              rotaY	       = 0;

	private double	          angle	       = 0.0;
	private double	          r	           = 0.0;
	private char	          rotateType	= 0;
	private double	          r2	       = 0.0;

	private double	          Pi	       = 3.14159265358979323846264338327950288419717;
	private boolean	          isDown	   = false;

	private TimerTask	      task	       = null;
	private Handler	          handler	   = null;
	private Timer	          timer	       = null;
	private boolean	          th_start	   = false;
	private static HttpClient	httpclient	= new DefaultHttpClient();

	private boolean	          timerrun	   = false;
	private static boolean	  sendFlag	   = false;

	private static char	      old_mode	   = 0;

	public ControlView(Context context)
	{
		super(context);

		this.setOnTouchListener(this);

		paint = new Paint();

		int color = Color.argb(255, 0xcc, 0xcc, 0xcc);
		paint.setColor(color);
		paint.setStrokeWidth(1);

		paintBLK = new Paint();
		color = Color.argb(255, 0x55, 0x55, 0x55);
		paintBLK.setColor(color);
		paintBLK.setStrokeWidth(1);

		paintM = new Paint();
		color = Color.argb(127, 0x55, 0x55, 0xff);
		paintM.setColor(color);
		paintM.setStrokeWidth(1);

		handler = new Handler()
		{
			public void handleMessage(Message msg)
			{
				switch (msg.what)
				{
					case 123:
						// Log.i("lidq", "timer running...");
						new Thread()
						{
							@Override
							public void run()
							{
								ControlView.ctlSendData((char) 0, (int) (angle * 180.0 / Pi), rotateType, (int) (r * 100.0), (int) (r2 * 100.0));
							}
						}.start();
						break;
				}
				super.handleMessage(msg);
			}
		};

		task = new TimerTask()
		{

			@Override
			public void run()
			{
				Message m = new Message();
				m.what = 123;
				handler.sendMessage(m);
			}
		};

		timer = new Timer();
		this.timerStart();
	}

	public void timerStart()
	{
		if (!timerrun)
		{
			timer.schedule(task, 1000, 100);
			timerrun = true;
		}
	}

	public void timerStop()
	{
		if (timerrun)
		{
			timer.cancel();
			timerrun = false;
		}
	}

	// 在这里我们将测试canvas提供的绘制图形方法
	@Override
	protected void onDraw(Canvas canvas)
	{
		drawMap(canvas);
	}

	private void drawMap(Canvas cancas)
	{
		int width = this.getWidth();
		int height = this.getHeight();
		int radius = width / 4;

		int cxDirect = width / 2;
		int cyDirect = height - radius - spacing;

		cancas.drawCircle(cxDirect, cyDirect, radius, paint);
		cancas.drawLine(cxDirect, cyDirect, cxDirect + radius, cyDirect + radius, paintBLK);
		cancas.drawLine(cxDirect, cyDirect, cxDirect - radius, cyDirect - radius, paintBLK);
		cancas.drawLine(cxDirect, cyDirect, cxDirect + radius, cyDirect - radius, paintBLK);
		cancas.drawLine(cxDirect, cyDirect, cxDirect - radius, cyDirect + radius, paintBLK);

		int rectWidth = radius / 3;
		int cxRotate = width / 2;
		int cyRotate = radius + spacing;

		int cxRotaLeft = cxRotate;
		int cyRotaLeft = cyRotate + 2 * rectWidth;
		int cxRotaRight = cxRotate;
		int cyRotaRight = cyRotate - 2 * rectWidth;

		cancas.drawRect(cxRotaRight - rectWidth, cyRotaRight - rectWidth, cxRotaLeft + rectWidth, cyRotaLeft + rectWidth, paint);

		if (!isDown)
		{
			directX = cxDirect;
			directY = cyDirect;

			rotaX = cxRotate;
			rotaY = cyRotate;
		}
		cancas.drawCircle(directX, directY, radius / 3, paintM);
		cancas.drawCircle(rotaX, rotaY, radius / 3, paintM);
	}

	public static void ctlSendDataLine(char mode, int angle, char ctl_rotate_type, int ra, int r2)
	{
		char ctl_direct = 0;
		char ctl_radius = (char) ra;

		if (ctl_rotate_type != 0)
		{
			ctl_radius = (char) r2;
		}

		if (angle >= 45 && angle <= 135)
		{
			ctl_direct = 0;
		}
		else if (angle >= 225 && angle <= 315)
		{
			ctl_direct = 1;
		}
		else if (angle < 45 || angle > 315)
		{
			ctl_direct = 2;
		}
		else if (angle > 135 && angle < 225)
		{
			ctl_direct = 3;
		}

		Socket socket = null;
		BufferedWriter bw = null;
		try
		{
			socket = new Socket(ip, port);
			bw = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));

			char[] cbuf = new char[4];

			cbuf[0] = mode;
			cbuf[1] = ctl_direct;
			cbuf[2] = ctl_rotate_type;
			cbuf[3] = ctl_radius;

			bw.write(cbuf);
			bw.flush();
		}
		catch (Exception e)
		{
			// e.printStackTrace();
		}
		finally
		{
			try
			{
				if (socket != null && bw != null)
				{
					bw.close();
					socket.close();
				}
			}
			catch (IOException e)
			{
				// e.printStackTrace();
			}
		}
	}

	public static void ctlSendData(char mode, int angle, char ctl_rotate_type, int ra, int r2)
	{
		if (mode == 0)
		{
			if (ctl_rotate_type == 0 && ra == 0 && sendFlag == false)
			{
				sendFlag = true;
				ctlSendDataLine(mode, angle, ctl_rotate_type, ra, r2);
			}
			else if (old_mode == 1 && mode == 0)
			{
				ctlSendDataLine(mode, angle, ctl_rotate_type, ra, r2);
			}
			if (ctl_rotate_type != 0 || ra != 0)
			{
				sendFlag = false;
				ctlSendDataLine(mode, angle, ctl_rotate_type, ra, r2);
			}
			old_mode = 0;
		}
		if (mode == 1)
		{
			ctlSendDataLine(mode, angle, ctl_rotate_type, ra, r2);
			old_mode = 1;
		}
	}

	public static HttpClient getHttpClient()
	{
		BasicHttpParams httpParams = new BasicHttpParams();
		HttpConnectionParams.setConnectionTimeout(httpParams, 100);
		HttpConnectionParams.setSoTimeout(httpParams, 100);
		HttpClient client = new DefaultHttpClient();
		return client;
	}

	@Override
	public boolean onTouch(View v, MotionEvent event)
	{
		int count = event.getPointerCount();

		int width = this.getWidth();
		int height = this.getHeight();
		int radius = width / 4;

		int cxDirect = width / 2;
		int cyDirect = height - radius - spacing;

		int rectWidth = radius / 3;
		int cxRotate = width / 2;
		int cyRotate = radius + spacing;
		int cyRotaLeft = cyRotate + 2 * rectWidth;
		int cyRotaRight = cyRotate - 2 * rectWidth;

		if (event.getAction() == MotionEvent.ACTION_UP)
		{
			// directX = cxDirect;
			// directY = cyDirect;
			isDown = false;
			r = 0.0;
			angle = 0.0;

			rotaX = cxRotate;
			rotaY = cyRotate;
			rotateType = 0;
			r2 = 0.0;
		}
		else
		{
			isDown = true;

			for (int i = 0; i < count; i++)
			{
				float x = event.getX(i);
				float y = event.getY(i);
				if (y > height / 2)
				{
					angle = 0;
					if (Math.abs(y - cyDirect) < 0.000001)
					{
						if (x < cxDirect)
						{
							angle = 0.0;
						}
						else
						{
							angle = Pi;
						}
					}
					else
					{
						angle = Math.atan((x - cxDirect) / (y - cyDirect));
					}

					r = Math.sqrt((x - cxDirect) * (x - cxDirect) + (y - cyDirect) * (y - cyDirect));
					if (r > radius)
					{

						if (y < cyDirect)
						{
							directX = cxDirect - (int) (radius * Math.sin(angle));
							directY = cyDirect - (int) (radius * Math.cos(angle));
						}
						else
						{
							directX = cxDirect + (int) (radius * Math.sin(angle));
							directY = cyDirect + (int) (radius * Math.cos(angle));
						}
						r = radius;
					}
					else
					{
						directX = (int) x;
						directY = (int) y;
					}

					if (x < cxDirect && y < cyDirect)
					{
						angle = ((Pi / 2) - angle) + (Pi / 2);
					}
					else if (x > cxDirect && y < cyDirect)
					{
						angle = Math.abs(angle) + Pi;
					}
					else if (x > cxDirect && y > cyDirect)
					{
						angle = ((Pi / 2) - angle) + (1.5 * Pi);
					}
					else if (x < cxDirect && y > cyDirect)
					{
						angle = Math.abs(angle);
					}

					r = (r / radius);
				}
				else
				{
					rotaX = cxRotate;
					rotaY = (int) y;

					if (rotaY > cyRotaLeft)
					{
						rotaY = cyRotaLeft;
					}
					if (rotaY < cyRotaRight)
					{
						rotaY = cyRotaRight;
					}
					// left
					if (rotaY - cyRotate > 0)
					{
						double d1 = (rotaY - cyRotate);
						double d2 = (cyRotaLeft - cyRotate);
						r2 = d1 / d2;
						rotateType = 1;
					}
					if (rotaY - cyRotate < 0)
					{
						double d1 = (cyRotate - rotaY);
						double d2 = (cyRotate - cyRotaRight);
						r2 = d1 / d2;
						rotateType = 2;
					}
				}
			}
		}
		postInvalidate();
		return true;
	}

}
