/*
 * engine.h
 *
 *  Created on: Apr 12, 2016
 *      Author: lidq
 */

#ifndef SRC_ENGINE_H_
#define SRC_ENGINE_H_

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <typedef.h>
#include <server.h>
#include <driver.h>

//ms
#define ENG_TIMER					(1000 / 60)
//ms
#define DIS_TIMER					(1000 / 100)
//ms
#define ENV_TIMER					(2)

#define MAX_SPEED					(100)
#define MIN_REDIRECT_BIT_DIS		(0.8)
#define MIN_REDIRECT_SMALL_DIS		(0.4)

//米
#define MAX_DISTANCE				(10.0)
//声波在空气中传播速度
#define SS_SPEED					(340.0)

#define Pi (3.14159265358979323846264338327950288419717)

typedef struct
{
		//0 is control mode
		//1 is auto mode
		int mode;

		//AUTO MODE
		double angle;
		double angle_diff;
		double va;
		//velocity and accelerated
		double left_v;
		double left_a;
		double right_v;
		double right_a;
		//auto params
		int redirect_leftright;
		int redirect_type;
		int redirect_reset;

		//CONTROL MODE
		//F B L R
		//0 1 2 3
		int ctl_direct;
		//0 is empty,
		//1 is turn left,
		//2 is turn right
		int ctl_rotate_type;
		//max value is 1.0
		double ctl_radius;
} s_engine;

void engine_reset(int mode);

void engine_control_set(int mode, int ctl_direct, int ctl_rotate_type, double ctl_radius);

void engine_server();

void engine_run();

void engine_move(s_engine *e);

void engine_rechk_speed(s_engine *e);

void engine_redirection(s_engine *e, double dis);

void engine_rand_params(s_engine *e);

void engine_control(s_engine *e);

extern void ifcar_set_speed(double left_v, double right_v);

extern double ifcar_impact_checking();

#endif /* SRC_ENGINE_H_ */
