/*
 * list.h
 *
 *  Created on: Oct 9, 2015
 *      Author: lidq
 */

#ifndef _LIST_H_
#define _LIST_H_

#include <typedef.h>

//表节点
typedef struct s_hash_list_node
{
	//关键字
	void *key;
	//数据指针
	void *data;
	//下一个节点
	struct s_hash_list_node *next;
} s_hash_list_node;

//表数据结构
typedef struct
{
	//头节点
	s_hash_list_node *header;
	//比较关键字回调函数
	int (*compare_key)();
	//用于释放节点关键字的回调函数
	void (*free_key)();
	//用于释放节点数据的回调函数
	void (*free_data)();
} s_hash_list;

//构建性表
boolean init_list(s_hash_list *list, int (*compare_key)(), void (*free_key)(), void (*free_data)());

//销毁表
boolean destroy_list(s_hash_list *list);

//清空表中所有元素
boolean clear_list(s_hash_list *list);

//插入一个新元素
boolean list_insert(s_hash_list *list, void *key, void *value);

//删除元素
boolean list_delete(s_hash_list *list, void *key);

//根据关键字取得数据
void* list_get(s_hash_list *list, void *key);

#endif
