/*
 * server.h
 *
 *  Created on: Mar 11, 2016
 *      Author: lidq
 */

#ifndef _INCLUDE_SERVER_H_
#define _INCLUDE_SERVER_H_

#include <typedef.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <semaphore.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <config.h>
#include <arpa/inet.h>
#include <setjmp.h>
#include <sys/syscall.h>
#include <signal.h>
#include <hash_list.h>
#include <fcntl.h>
#include <dirent.h>
#include <control.h>

typedef struct server
{
	//网络套接字
	int socket_descriptor;
	//套接字IP地址
	struct sockaddr_in servaddr;
	//信号量
	sem_t sem_engine;
	sem_t sem_driver_left;
	sem_t sem_driver_right;
	sem_t sem_distance;
	sem_t sem_server;
	sem_t sem_connection;
	sem_t sem_new_accept;
	pthread_t thread_engine;
	pthread_t thread_conn;
} s_server;

int compare_addr(void *p, void *p2);

boolean make_socket_non_blocking(int sfd);

//启动服务
boolean server_start();

//停止服务
void server_stop();

void engine_start();

void engine_create();

void driver_create_distance();

void driver_start();

void driver_create_left();

void driver_create_right();

//创建新的等待连接
boolean server_create_connection();

//关闭套接字
void server_close_socket(int socket);

void exception_handler(int sig);

void server_engine();

#endif /* INCLUDE_SERVER_H_ */

