/*
 * dt_config.c
 *
 *  Created on: Jan 18, 2016
 *      Author: lidq
 */

#include <config.h>

//载入配置文件
boolean config_load(s_config *config)
{
	if (config == null)
	{
		return false;
	}

	//取得BIS_DT_PATH系统环境变量
	s8 *mycar_path = getenv(MYCAR_PATH);
	if (mycar_path == null)
	{
		return false;
	}

	s8 config_path[BUFF_SIZE];
	int n = snprintf(config_path, BUFF_SIZE, "%s/etc/mycar.conf", mycar_path);
	if (n <= 0)
	{
		return false;
	}
	//使用只读文本方式打开配置文件
	FILE *fp = fopen(config_path, "rt");
	if (fp == null)
	{
		return false;
	}

	s8 ch;
	s8 line[BUFF_SIZE];
	s8 name[BUFF_SIZE];
	int i = 0;
	u32 value = 0;
	while ((ch = fgetc(fp)) != EOF)
	{
		if (ch == 255)
		{
			break;
		}

		line[i++] = ch;
		if (ch == '\n')
		{
			line[i] = '\0';
			if (line[0] == '\0')
			{
				continue;
			}
			sscanf(line, "%[^=]=%d", name, &value);
			if (strcmp("max_client_count", name) == 0)
			{
				config->max_client_count = value;
			}
			if (strcmp("max_accept_count", name) == 0)
			{
				config->max_accept_count = value;
			}
			if (strcmp("bind_wait_secs", name) == 0)
			{
				config->bind_wait_secs = value;
			}
			if (strcmp("server_port", name) == 0)
			{
				config->server_port = value;
			}
			i = 0;
		}
	}
	return true;
}

